## python3.12 3.12.3

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
JOBS         = auto
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
REQUIREMENTS = requirements.txt
SPHINXERRORHANDLING = -W

# Internal variables.
PAPEROPT_a4     = -D latex_elements.papersize=a4paper
PAPEROPT_letter = -D latex_elements.papersize=letterpaper

ALLSPHINXOPTS = -b $(BUILDER) \
                -d build/doctrees \
                -j $(JOBS) \
                $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) $(SPHINXERRORHANDLING) \
                . build/$(BUILDER) $(SOURCES)

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmllive   to rebuild and reload HTML files in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  texinfo    to make Texinfo file"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  check      to run a check for frequent markup errors"

.PHONY: build
build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif $(BLURB) help >/dev/null 2>&1 && $(SPHINXBUILD) --version >/dev/null 2>&1; then \
		if [ -d ../Misc/NEWS.d ]; then \
			echo "Building NEWS from Misc/NEWS.d with blurb"; \
			$(BLURB) merge -f build/NEWS; \
		else \
			echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
			exit 1; \
		fi \
	else \
		echo ""; \
		echo "Missing the required blurb or sphinx-build tools."; \
		echo "Please run 'make venv' to install local copies."; \
		echo ""; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

.PHONY: html
html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

.PHONY: htmlhelp
htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

.PHONY: latex
latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

.PHONY: text
text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

.PHONY: texinfo
texinfo: BUILDER = texinfo
texinfo: build
	@echo "Build finished; the python.texi file is in build/texinfo."
	@echo "Run \`make info' in that directory to run it through makeinfo."

.PHONY: epub
epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

.PHONY: changes
changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

.PHONY: linkcheck
linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

.PHONY: coverage
coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

.PHONY: doctest
doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

.PHONY: pydoc-topics
pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

.PHONY: htmlview
htmlview: html
	$(PYTHON) -c "import os, webbrowser; webbrowser.open('file://' + os.path.realpath('build/html/index.html'))"

.PHONY: htmllive
htmllive: SPHINXBUILD = $(VENVDIR)/bin/sphinx-autobuild
htmllive: SPHINXOPTS = --re-ignore="/venv/" --open-browser --delay 0
htmllive: html

.PHONY: clean
clean: clean-venv
	-rm -rf build/*

.PHONY: clean-venv
clean-venv:
	rm -rf $(VENVDIR)

.PHONY: venv
venv:
	@if [ -d $(VENVDIR) ] ; then \
		echo "venv already exists."; \
		echo "To recreate it, remove it first with \`make clean-venv'."; \
	else \
		echo "Creating venv in $(VENVDIR)"; \
		$(PYTHON) -m venv $(VENVDIR); \
		$(VENVDIR)/bin/python3 -m pip install --upgrade pip; \
		$(VENVDIR)/bin/python3 -m pip install -r $(REQUIREMENTS); \
		echo "The venv has been created in the $(VENVDIR) directory"; \
	fi

.PHONY: dist
dist:
	rm -rf dist
	mkdir -p dist

	# archive the HTML
	make html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar

	# archive the text build
	make text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar

	# archive the A4 latex
	rm -rf build/latex
	make latex PAPER=a4
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2

	# archive the letter latex
	rm -rf build/latex
	make latex PAPER=letter
	-sed -i 's/makeindex/makeindex -q/' build/latex/Makefile
	(cd build/latex; make clean && make all-pdf && make FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-letter.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-letter.tar.bz2

	# copy the epub build
	rm -rf build/epub
	make epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub

	# archive the texinfo build
	rm -rf build/texinfo
	make texinfo
	make info --directory=build/texinfo
	cp -pPR build/texinfo dist/python-$(DISTVERSION)-docs-texinfo
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-texinfo.tar python-$(DISTVERSION)-docs-texinfo
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-texinfo.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-texinfo.zip python-$(DISTVERSION)-docs-texinfo)
	rm -r dist/python-$(DISTVERSION)-docs-texinfo
	rm dist/python-$(DISTVERSION)-docs-texinfo.tar

.PHONY: check
check: venv
	$(VENVDIR)/bin/python3 -m pre_commit --version > /dev/null || $(VENVDIR)/bin/python3 -m pip install pre-commit
	$(VENVDIR)/bin/python3 -m pre_commit run --all-files

.PHONY: serve
serve:
	@echo "The serve target was removed, use htmlview instead (see bpo-36329)"

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# `-E` (to ignore the cached environment) and `-a` (to ignore already existing
# output files)

# for development releases: always build
.PHONY: autobuild-dev
autobuild-dev:
	make dist SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for quick rebuilds (HTML only)
.PHONY: autobuild-dev-html
autobuild-dev-html:
	make html SPHINXOPTS='$(SPHINXOPTS) -Ea -A daily=1'

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
.PHONY: autobuild-stable
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev

.PHONY: autobuild-stable-html
autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@make autobuild-dev-html

=== debian/changelog ===
python3.12 (3.12.3-1) unstable; urgency=medium

  * Python 3.12.3 release.

 -- Matthias Klose <doko@debian.org>  Wed, 10 Apr 2024 07:33:47 +0200

python3.12 (3.12.2-5) unstable; urgency=medium

  * Update to the 3.12 branch 2024-02-02.
    - Make C API compatible with ISO C90 (GH-116950). Closes: #1064028.
    - Upstream patch for GH-115874.
    - Still identify as "3.12.2", because "3.12.2+" is mis-treated by some
      third-party packages.
  * Use CFLAGS_NODIST, LDFLAGS_NODIST for passing build flags.
  * d/rules: Move configure/build targets for each build together.
  * Drop ffi configure options, obsolete.
  * Re-enable PGO/LTO builds.

 -- Matthias Klose <doko@debian.org>  Tue, 02 Apr 2024 16:53:02 +0200

python3.12 (3.12.2-4) unstable; urgency=medium

  [ Stefano Rivera ]
  * Build-Depend on libnsl-dev for NIS support. Closes: #1065128.

  [ Matthias Klose ]
  * Fix override files for renamed t64 packages.
  * Fix package names in PVER-dbg maintainer scripts. Addresses: #1065164.
  * Really build without LTO when requested.
  * Disable LTO builds and testsuite for now (mesa t64 transition ...).

 -- Matthias Klose <doko@debian.org>  Sun, 03 Mar 2024 10:11:00 +0100

python3.12 (3.12.2-3) unstable; urgency=medium

  * Actually apply the teedataobject_clear patch. Closes: #1063345.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 29 Feb 2024 11:43:19 -0400

python3.12 (3.12.2-2) unstable; urgency=medium

  [ Colin Watson ]
  * Don't rely on module state in teedataobject_clear (from Brandt Bucher in
    https://github.com/python/cpython/issues/115874). Closes: #1063345.

  [ Steve Langasek ]
  * Rename libraries for 64-bit time_t transition, declare X-Time64-Compat
    to get proper Provides (Steve Langasek). Closes: #1064336.

 -- Matthias Klose <doko@debian.org>  Thu, 29 Feb 2024 02:56:09 +0100

python3.12 (3.12.2-1) unstable; urgency=medium

  * Python 3.12.2 release.
  * Don't build-depend on systemtap-sdt-dev on the Hurd.
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Feb 2024 21:47:03 +0100

=== debian/control ===
Source: python3.12
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Uploaders: Stefano Rivera <stefanor@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev | libeditreadline-dev, libncurses-dev, 
  zlib1g-dev, libbz2-dev, liblzma-dev,
  libgdbm-dev, libdb-dev,
#  tk-dev, blt-dev (>= 2.4z),
  libssl-dev,
  libexpat1-dev,
  libbluetooth-dev [linux-any] <!pkg.python3.12.nobluetooth>,
  locales-all,
  libnsl-dev,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.12:any <cross>,
  net-tools,
#  xvfb <!nocheck>, xauth <!nocheck>, tzdata <!nocheck>,
  systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
  valgrind-if-available,
Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.12
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.12-minimal (= ${binary:Version}),
 libpython3.12-stdlib (= ${binary:Version}),
 media-types | mime-support, tzdata,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Suggests: python3.12-venv, python3.12-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.12)
 Python is a high-level, interactive, object-oriented language. Its 3.12 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.12-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.12 (= ${binary:Version}),
 python3-pip-whl (>= 22.2),
 python3-setuptools-whl,
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.12)
 Python is a high-level, interactive, object-oriented language. Its 3.12 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.12 binary.

Package: libpython3.12-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.12-minimal (= ${binary:Version}),
  media-types | mime-support, netbase, tzdata,
  ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-gdbm (<< 3.9.9-1~), libpython3.12-testsuite (<< 3.12.0-3~)
Replaces: python3-gdbm (<< 3.9.9-1~), libpython3.12-testsuite (<< 3.12.0-3~)
Description: Interactive high-level object-oriented language (standard library, version 3.12)
 Python is a high-level, interactive, object-oriented language. Its 3.12 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.12's standard library. It is normally not
 used on its own, but as a dependency of python3.12.

Package: python3.12-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.12-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.12
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.12)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.12-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.12

Package: python3.12-nopie
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.12-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Python interpreter linked without PIE (version 3.12)
 This package contains the interpreter not built as position independent
 executable. This interpreter is diverting the python3.12 executable, and making
 the interpreter built with PIE available as python3.12-pie.
XB-Cnf-Visible-Pkgname: python3.12

Package: libpython3.12-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.12-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.12)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.12-minimal.

Package: libpython3.12t64
Provides: ${t64:Provides}
Replaces: libpython3.12
Breaks: libpython3.12 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.12-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.12)
 Python is a high-level, interactive, object-oriented language. Its 3.12 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.12-examples
Architecture: all
Depends: python3.12:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.12)
 Examples, Demos and Tools for Python (v3.12). These are files included in
 the upstream Python distribution (v3.12).

Package: python3.12-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.12 (= ${binary:Version}),
  libpython3.12-dev (= ${binary:Version}),
  libpython3.12t64 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.12)
 Header files, a static library and development tools for building
 Python (v3.12) modules, extending the Python interpreter or embedding
 Python (v3.12) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.12-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.12-stdlib (= ${binary:Version}),
  libpython3.12t64 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.12)
 Header files, a static library and development tools for building
 Python (v3.12) modules, extending the Python interpreter or embedding
 Python (v3.12) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.12-dev.

Package: libpython3.12-testsuite
Section: libdevel
Architecture: all
Depends: python3.12 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.12)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.12-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.12-stdlib package).

Package: idle-python3.12
Architecture: all
Depends: python3.12, python3-tk, python3.12-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.12
Description: IDE for Python (v3.12) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.12).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.12-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.12
Description: Documentation for the high-level object-oriented language Python (v3.12)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.12). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.12
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.12-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.12 (= ${binary:Version}), libpython3.12t64-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.12)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.12t64-dbg
X-Time64-Compat: libpython3.12-dbg
Provides: ${t64:Provides}
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.12-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: libpython3.12-dbg (<< ${source:Version}), python3-gdbm-dbg (<< 3.9.9-1~)
Replaces: libpython3.12-dbg, python3-gdbm-dbg (<< 3.9.9-1~)
Description: Debug Build of the Python Interpreter (version 3.12)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.12-full
Architecture: any
Multi-Arch: allowed
Depends: python3.12 (= ${binary:Version}),
  libpython3.12-testsuite,
  python3.12-venv (= ${binary:Version}),
  idle-python3.12,
  python3.12-gdbm,
  python3.12-lib2to3,
  python3.12-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.12-doc, python3.12-examples,
Suggests: python3.12-dev
Description: Python Interpreter with complete class library (version 3.12)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv and lib2to3, and modules with
 complex dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

=== debian/rules ===
#!/usr/bin/make -f

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
DPKG_VARS	:= $(shell dpkg-architecture)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)

LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390 hurd-i386 kfreebsd-amd64 kfreebsd-i386))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH := yes
WITHOUT_CHECK := yes

COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

# we inject our own lto flags
DPKG_OPTIMIZE = optimize=-lto
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)"dpkg-buildflags
ifeq (,$(filter $(distrelease),stretch buster bullseye trusty xenial bionic focal impish))
  with_nopie := yes
  dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
endif

# FIXME: remove sid when uploading to unstable, after bookworm is released
#ifneq (,$(filter $(distrelase), jessie stretch buster bullseye bookworm sid precise trusty xenial bionic focal groovy hirsute))
  with_dbmmodule = yes
  bd_dbm = libdb-dev
  dbmliborder = bdb:gdbm
#else
#  bd_dbm = libgdbm-compat-dev
#  dbmliborder = gdbm:bdb
#endif

ifneq (,$(filter valgrind, $(shell dpkg-query --show -f '$${Depends}\n' valgrind-if-available)))
  valgrind_configure_args = --with-valgrind
endif

VER=3.12
SVER=3.12.1
NVER=3.13
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := no
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

DPKG_PIE_CPPFLAGS= $(shell $(dpkg_pieflags) --get CPPFLAGS)
DPKG_PIE_CFLAGS  := $(shell $(dpkg_pieflags) --get CFLAGS)
DPKG_PIE_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_PIE_CFLAGS))
DPKG_PIE_LDFLAGS = $(shell $(dpkg_pieflags) --get LDFLAGS)
OPT_PIE_CFLAGS   := $(filter-out -O%,$(DPKG_PIE_CFLAGS)) # default is -O3

ifeq ($(DEB_HOST_ARCH),ia64)
    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
    DPKG_PIE_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
endif
# see #972202, and https://gcc.gnu.org/PR97431
ifneq (,$(filter $(DEB_HOST_ARCH), hppa sh4))
    EXTRA_OPT_CFLAGS += -fno-inline-small-functions
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.12-dev,
  libpython3.12-testsuite:native,
  python3-gdbm (>= 3.11.4),
  python3-distutils,
  python3-tk (>= 3.11.4),
  idle-python3.12,
  systemtap-sdt-dev,
  python3.12-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: testsuite-dbg
Depends: build-essential,
  ca-certificates,
  locales-all, python3.12-dev,
  python3.12-dbg,
  libpython3.12-testsuite:native,
  python3-gdbm-dbg (>= 3.11.4),
  gdb,
  python3-distutils,
  python3-tk-dbg (>= 3.11.4),
  idle-python3.12,
  systemtap-sdt-dev,
  python3.12-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.12-dev,
  libpython3.12-testsuite:native,
  python3-gdbm (>= 3.11.4),
  python3-tk (>= 3.11.4),
  python3-distutils,
  python3.12-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.12-dev,
  python3.12-dbg,
  libpython3.12-testsuite:native,
  python3-gdbm-dbg (>= 3.11.4),
  python3-tk-dbg (>= 3.11.4),
  gdb,
  python3-distutils,
  python3.12-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: module-install-local
Depends: build-essential,
  python3.12-dev,
  python3-pip,
  python3-setuptools,
  shunit2,
Restrictions: needs-root, allow-stderr

Tests: module-install-user
Depends: build-essential,
  python3.12-dev,
  python3-pip,
  python3-setuptools,
  shunit2
Restrictions: allow-stderr

Tests: module-install-venv
Depends: build-essential,
  python3.12-dev,
  python3.12-venv,
  python3-setuptools-whl,
  python3-wheel-whl,
  shunit2
Restrictions: allow-stderr

Tests: module-install-virtualenv
Depends: build-essential,
  python3.12-dev,
  shunit2,
  virtualenv,
  python3-setuptools-whl,
  python3-wheel-whl
Restrictions: allow-stderr

## python3.12 3.12.4

=== Doc/requirements.txt ===
# Requirements to build the Python documentation
#
# Note that when updating this file, you will likely also have to update
# the Doc/constraints.txt file.

# Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
sphinx~=7.3.0

blurb

sphinxext-opengraph==0.7.5
sphinx-notfound-page==1.0.0

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2023.3.1,!=2023.7

-c constraints.txt

=== debian/changelog ===
python3.12 (3.12.4-1ubuntu1) oracular; urgency=medium

  [ Benjamin Drung ]
  * debian/rules: Use pkg-info.mk
  * debian/rules: Use architecture.mk
  * d/rules: Export variable needed for ELF package metadata
  * Rely on SOURCE_DATE_EPOCH for reproducibility

  [ Graham Inggs ]
  * Drop test dependencies on python3-distutils
  * Skip test_exceptions and test_repl which never run to
    completion on the Ubuntu autopkgtest infrastructure

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 27 Jun 2024 13:53:59 +0000

python3.12 (3.12.4-1) unstable; urgency=medium

  * Python 3.12.4 release.
  * Refresh patches.
  * Patch: Ignore test/wheeldata completely in test_makefile.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 12 Jun 2024 20:06:53 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,7 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/pkg-info.mk
 
 unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
 unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS
@@ -7,16 +10,6 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-
-vafilt		= $(subst $(2)=,,$(filter $(2)=%,$(1)))
-DPKG_VARS	:= $(shell dpkg-architecture)
-DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
-DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
-DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
-DEB_HOST_ARCH_ENDIAN	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_ENDIAN)
-DEB_HOST_ARCH_OS	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_OS)
-DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
-DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)
 
 ifeq ($(DEB_HOST_ARCH_OS),linux)
   PLAT = linux
@@ -29,18 +22,15 @@
   PLAT = unknown
 endif
 
-CHANGELOG_VARS := $(shell dpkg-parsechangelog | \
-	sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
-PKGSOURCE  := $(call vafilt,$(CHANGELOG_VARS),Source)
-PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
-
-LAST_CHANGE := $(shell dpkg-parsechangelog -S Date)
-export BUILD_DATE := $(shell LC_ALL=C date -u +'%b %e %Y' -d '$(LAST_CHANGE)')
-export BUILD_TIME := $(shell LC_ALL=C date -u +'%H:%M:%S' -d '$(LAST_CHANGE)')
-
-SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
-SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '$(LAST_CHANGE)')'
+SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
+SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
 export SPHINXOPTS
+
+# Export variables needed for ELF package metadata
+export DEB_BUILD_OS_RELEASE_ID=$(shell . /usr/lib/os-release && echo $$ID)
+export DEB_HOST_ARCH
+export DEB_SOURCE
+export DEB_VERSION
 
 on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)
 
@@ -228,3 +218,26 @@
 endif
 
 ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
+    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS))
+    EXTRA_OPT_CFLAGS = -O0
+    with_pgo =
+    with_lto =
+endif
+
+BASE_LTO_CFLAGS = -g -fwrapv -O3
+ifeq ($(with_lto),yes)
+    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
+    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
+			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
+    ifeq ($(with_fat_lto),yes)
+      LTO_CFLAGS += -ffat-lto-objects
+    endif
+    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
+    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
+    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
+endif
+
+sysconfig_substflags = \
+	$(if $(with_lto),$(foreach i,-flto=auto -flto -fuse-linker-plugin -ffat-lto-objects,-e 's/$(i)//g')) \
+	-e '/^OPT/s,-O3,-O2,' \
+	-e 's/-O3/-O2/g' \

=== debian/tests/control ===
--- 
+++ 
@@ -5,7 +5,6 @@
   python3.12-dev,
   libpython3.12-testsuite:native,
   python3-gdbm (>= 3.11.4),
-  python3-distutils,
   python3-tk (>= 3.11.4),
   idle-python3.12,
   systemtap-sdt-dev,
@@ -21,7 +20,6 @@
   libpython3.12-testsuite:native,
   python3-gdbm-dbg (>= 3.11.4),
   gdb,
-  python3-distutils,
   python3-tk-dbg (>= 3.11.4),
   idle-python3.12,
   systemtap-sdt-dev,
@@ -37,7 +35,6 @@
   libpython3.12-testsuite:native,
   python3-gdbm (>= 3.11.4),
   python3-tk (>= 3.11.4),
-  python3-distutils,
   python3.12-venv,
 # need to turn off apport
 Restrictions: needs-root, allow-stderr
@@ -52,7 +49,6 @@
   python3-gdbm-dbg (>= 3.11.4),
   python3-tk-dbg (>= 3.11.4),
   gdb,
-  python3-distutils,
   python3.12-venv,
 # need to turn off apport
 Restrictions: needs-root, allow-stderr

## python3.12 3.12.7

=== debian/changelog ===
python3.12 (3.12.7-1) unstable; urgency=medium

  * Python 3.12.7 release.
  * Refresh patches.
  * Build-Depend on python3-{pip,setuptools,wheel}-whl for tests.
  * Verify upstream PGP signature.
  * Patch: Strip absolute --libdir paths from configure args in test_freeze.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 03 Oct 2024 09:15:22 -0600

python3.12 (3.12.6-1) unstable; urgency=medium

  * Python 3.12.6 release.
    - Fixes: CVE-2015-2104, CVE-2023-27043 (Closes: #1059299), CVE-2024-4030,
      CVE-2024-4032, CVE-2024-6232, CVE-2024-6923, CVE-2024-7592, and
      CVE-2024-8088.
  * Refresh patches.
  * Remove debian/locale-gen, we use locales-all. (Closes: #1076778)
  * Re-enable build-time tests. (Closes: #1076779)
    - Build-Depend on xvfb and xauth again.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 07 Sep 2024 16:20:15 +0200

python3.12 (3.12.5-4) unstable; urgency=medium

  * python3.x-tk: Make byte-compilation depend on the availability of
    the interpreter.

 -- Matthias Klose <doko@debian.org>  Thu, 22 Aug 2024 15:11:09 +0200

python3.12 (3.12.5-3) unstable; urgency=medium

  * Add python3.x-tk maintainer scripts.
  * Call dpkg with LC_ALL=C.UTF8 set.

 -- Matthias Klose <doko@debian.org>  Thu, 22 Aug 2024 09:49:39 +0200

python3.12 (3.12.5-2) experimental; urgency=medium

  * Build python3.12-gdbm and python3.12-tk packages again; Having these
    extensions hidden in the libpython-stdlib packages raises some chrootkit
    warnings. These packages should not be used as dependencies, and do not
    depend on the Python interpreter.  For dependencies, the existing
    python3-gdbm and python3-tk packages should be used.

 -- Matthias Klose <doko@debian.org>  Wed, 21 Aug 2024 09:45:53 +0200

python3.12 (3.12.5-1) unstable; urgency=medium

  * Python 3.12.5 release.
  * libpython-stdlib: Include the _gdbm and _tkinter extensions, prefixed
    with a dot, and no dependencies on the gbm and tcl/tk libraries.
  * Refresh patches.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 07 Aug 2024 15:49:14 +0200

python3.12 (3.12.4-3) unstable; urgency=medium

  [ Matthias Klose ]
  * Set ELF_PACKAGE_METADATA, if unset.
  * Fix multiarch path for hurd-amd64. Closes: #1076321.
  * Don't configure -with-dtrace on the Hurd. Closes: #1065456.
  * Update from the 3.12 branch 2024-07-15.

  [ Benjamin Drung ]
  * debian/rules: Use pkg-info.mk.
  * debian/rules: Use architecture.mk.
  * Rely on SOURCE_DATE_EPOCH for reproducibility.

  [ Graham Inggs ]
  * Drop test dependencies on python3-distutils.
  * Skip test_exceptions and test_repl which never run to
    completion on the Ubuntu autopkgtest infrastructure.

 -- Matthias Klose <doko@debian.org>  Mon, 15 Jul 2024 14:17:32 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
   libreadline-dev | libeditreadline-dev, libncurses-dev, 
   zlib1g-dev, libbz2-dev, liblzma-dev,
   libgdbm-dev, libdb-dev,
-#  tk-dev, blt-dev (>= 2.4z),
+  tk-dev, blt-dev (>= 2.4z),
   libssl-dev,
   libexpat1-dev,
   libbluetooth-dev [linux-any] <!pkg.python3.12.nobluetooth>,
@@ -19,11 +19,15 @@
   libgpm2 [linux-any],
   media-types | mime-support, netbase, bzip2, time, python3:any, python3.12:any <cross>,
   net-tools,
-#  xvfb <!nocheck>, xauth <!nocheck>, tzdata <!nocheck>,
+  python3-pip-whl <!nocheck>,
+  python3-setuptools-whl <!nocheck>,
+  python3-wheel-whl <!nocheck>,
+  xvfb <!nocheck>, xauth <!nocheck>,
+  tzdata <!nocheck>,
   systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
   valgrind-if-available,
 Build-Depends-Indep: python3-sphinx, python3-docs-theme, texinfo
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/cpython-team/python3
 Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
 XS-Testsuite: autopkgtest
@@ -248,8 +252,10 @@
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: libpython3.12-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
-Breaks: libpython3.12-dbg (<< ${source:Version}), python3-gdbm-dbg (<< 3.9.9-1~)
-Replaces: libpython3.12-dbg, python3-gdbm-dbg (<< 3.9.9-1~)
+Breaks: libpython3.12-dbg (<< ${source:Version}),
+  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
+Replaces: libpython3.12-dbg,
+  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
 Description: Debug Build of the Python Interpreter (version 3.12)
  The package holds two things:
  .
@@ -284,3 +290,25 @@
  .
  According to the Debian Python policy, this package must not be used in
  build dependencies, dependencies and recommendations.
+
+Package: python3.12-tk
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Enhances: python3.12
+Suggests: tix
+Breaks: python3-tk (<< 3.12.5-2~)
+Replaces: python3-tk (<< 3.12.5-2~)
+XB-Python-Version: 3.12
+Description: Tkinter - Writing Tk applications with Python (v3.12)
+ A module for writing portable GUI applications with Python (v3.12) using Tk.
+ Also known as Tkinter.
+
+Package: python3.12-gdbm
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Enhances: python3.12
+Breaks: python3-gdbm (<< 3.12.5-2~)
+Replaces: python3-gdbm (<< 3.12.5-2~)
+Description: GNU dbm database support for Python (v3.12)
+ GNU dbm database module for Python. Install this if you want to
+ create or read GNU dbm database files with Python.

=== debian/rules ===
--- 
+++ 
@@ -25,12 +25,6 @@
 SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
 SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
 export SPHINXOPTS
-
-# Export variables needed for ELF package metadata
-export DEB_BUILD_OS_RELEASE_ID=$(shell . /usr/lib/os-release && echo $$ID)
-export DEB_HOST_ARCH
-export DEB_SOURCE
-export DEB_VERSION
 
 on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)
 
@@ -55,9 +49,8 @@
   WITHOUT_BENCH := yes
   WITHOUT_CHECK := yes
 endif
-WITHOUT_BENCH := yes
-WITHOUT_CHECK := yes
-
+
+SPACE = $(EMPTY) $(EMPTY)
 COMMA = ,
 ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
   NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
@@ -69,6 +62,19 @@
 	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
 	elif dpkg-vendor --derives-from Debian; then echo Debian; \
 	else echo Unknown; fi)
+
+# package metadata information
+ifeq (,$(ELF_PACKAGE_METADATA))
+  ELF_PACKAGE_METADATA := $(subst $(SPACE),,{ \
+        "type":"deb", \
+        "os":"$(shell awk -F= '/^ID=/ {print $$2}' /etc/os-release)", \
+        "name":"$(DEB_SOURCE)", \
+        "version":"$(DEB_VERSION)", \
+        "architecture":"$(DEB_HOST_ARCH)" \
+        $(if $(DEB_BUILD_DEBUG_INFO_URL),$(COMMA)"debugInfoUrl":"$(DEB_BUILD_DEBUG_INFO_URL)") \
+    })
+  export ELF_PACKAGE_METADATA
+endif
 
 # we inject our own lto flags
 DPKG_OPTIMIZE = optimize=-lto
@@ -123,7 +129,8 @@
 			encodings/$(i)) \
 		 codecs.py stringprep.py
 
-with_tk := no
+with_tk := yes
+with_gdbm := yes
 with_interp := static
 #with_interp := shared
 
@@ -232,12 +239,3 @@
     ifeq ($(with_fat_lto),yes)
       LTO_CFLAGS += -ffat-lto-objects
     endif
-    EXTRA_OPT_CFLAGS += $(LTO_CFLAGS)
-    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
-    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
-endif
-
-sysconfig_substflags = \
-	$(if $(with_lto),$(foreach i,-flto=auto -flto -fuse-linker-plugin -ffat-lto-objects,-e 's/$(i)//g')) \
-	-e '/^OPT/s,-O3,-O2,' \
-	-e 's/-O3/-O2/g' \

=== debian/tests/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
   locales-all,
   python3.12-dev,
   libpython3.12-testsuite:native,
-  python3-gdbm (>= 3.11.4),
-  python3-tk (>= 3.11.4),
+  python3.12-gdbm,
+  python3.12-tk,
   idle-python3.12,
   systemtap-sdt-dev,
   python3.12-venv,
@@ -18,9 +18,7 @@
   locales-all, python3.12-dev,
   python3.12-dbg,
   libpython3.12-testsuite:native,
-  python3-gdbm-dbg (>= 3.11.4),
   gdb,
-  python3-tk-dbg (>= 3.11.4),
   idle-python3.12,
   systemtap-sdt-dev,
   python3.12-venv,
@@ -33,8 +31,8 @@
   locales-all,
   python3.12-dev,
   libpython3.12-testsuite:native,
-  python3-gdbm (>= 3.11.4),
-  python3-tk (>= 3.11.4),
+  python3.12-gdbm,
+  python3.12-tk,
   python3.12-venv,
 # need to turn off apport
 Restrictions: needs-root, allow-stderr
@@ -46,8 +44,6 @@
   python3.12-dev,
   python3.12-dbg,
   libpython3.12-testsuite:native,
-  python3-gdbm-dbg (>= 3.11.4),
-  python3-tk-dbg (>= 3.11.4),
   gdb,
   python3.12-venv,
 # need to turn off apport

=== debian/watch ===
version=4
opts=dversionmangle=s/.*\+//,\
  uversionmangle=s/([abcr]+[1-9])$/~$1/,\
  pgpsigurlmangle=s/$/.asc/ \
  http://www.python.org/ftp/python/3\.12(\.\d)?/Python-(3\.12[.\dabcr]*)\.tar.xz
